package cz.cvut.fel.f2p.skladaniVln;

import java.util.ArrayList;

import net.java.games.jogl.GL;
import net.java.games.jogl.GLDrawable;
import net.java.games.jogl.GLEventListener;
import net.java.games.jogl.GLU;

public class Renderer implements GLEventListener {

	public static int VALUES_COUNT = 720;

	private CameraSettings camSettings;

	private ArrayList<Double> values;

	private SkladaniVln canvasPanel;

	private boolean isPaused = true;

	private static double translation = 8;

	private ArrayList<ArrayList<Double>> vArray;

	private long time = 0;

	private int vawesCount;

	private double amplitude;

	private double k;

	private double step;

	private double omegap;
	
	private int vawesCountForAdding;

	public Renderer(SkladaniVln p) {
		super();
		vArray = new ArrayList<ArrayList<Double>>();
		canvasPanel = p;
		camSettings = new CameraSettings();
		compute();
	}

	@SuppressWarnings("unchecked")
	public void compute() {
		vArray = new ArrayList<ArrayList<Double>>();
		values = new ArrayList<Double>();

		amplitude = 5;
		if (canvasPanel.getAmplitud() != null) {
			amplitude = Double.parseDouble(canvasPanel.getAmplitud().getText());
		}
		k = 20;
		if (canvasPanel.getK() != null) {
			k = Double.parseDouble(canvasPanel.getK().getText());
		}
		step = 0.01;
		if (canvasPanel.getStepAdd() != null) {
			step = Double.parseDouble(canvasPanel.getStepAdd().getText());
		}

		vawesCount = 1;
		if (canvasPanel.getVawesCount() != null) {
			vawesCount = canvasPanel.getVawesCount().getValue();
		}
		
		vawesCountForAdding = 500;
		if (canvasPanel.getVawesCount() != null) {
			vawesCountForAdding = Integer.parseInt(canvasPanel.getVawesCountForAdding().getText());
			if (vawesCountForAdding == 1) {
				vawesCountForAdding = 2;
			}
		}

		omegap = 10;
		if (canvasPanel.getStepAdd() != null) {
			omegap = Double.parseDouble(canvasPanel.getOmegap().getText());
		}

		for (int j = 0; j < vawesCount; j++) {

			values = new ArrayList<Double>();

			for (int i = 0; i < VALUES_COUNT; i++) {
				double cy = 0;
				for (int l = -vawesCountForAdding/2; l < vawesCountForAdding/2; l++) {
					double fi = ((double) (i) / 360) * Math.PI
							* ((k + (double) l * step));
					if (canvasPanel.getOmegaSQRT() != null
							&& canvasPanel.getOmegaSQRT().isSelected()) {
						double ff = Math.sqrt(Math.PI
								* ((k + (double) l * step)) * Math.PI
								* ((k + (double) l * step)) + omegap * omegap);
						fi = ((double) (i) / 360) * ff;
					}
					cy += amplitude
							* Math
									.cos(((k + (double) l * step) * (j * 0.5) - fi));
				}
				cy = cy / (vawesCountForAdding+1);
				values.add(cy);

			}
			vArray.add((ArrayList<Double>) values.clone());
		}

		if (canvasPanel.getTime() != null) {
			if (canvasPanel.getTimePlus().isSelected()) {
				canvasPanel.getTime().setText(String.valueOf(-VALUES_COUNT));
			} else {
				canvasPanel.getTime().setText("0");
			}
		}
	}

	public void display(GLDrawable drawable) {
		GL gl = drawable.getGL();
		GLU glu = drawable.getGLU();

		camSettings.compute(gl);

		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT
				| GL.GL_STENCIL_BUFFER_BIT);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(60, 1, 0.01, 50);
		gl.glTranslated(camSettings.getCameraTranslationX(), camSettings
				.getCameraTranslationY(), 0);
		glu.gluLookAt(camSettings.getCameraEyeX(), camSettings.getCameraEyeY(),
				camSettings.getCameraEyeZ(), 0, 0, 0, camSettings
						.getCameraUpX(), camSettings.getCameraUpY(),
				camSettings.getCameraUpZ());

		if (canvasPanel.getFill().isSelected()) {
			gl.glDisable(GL.GL_DEPTH_TEST);
			gl.glEnable(GL.GL_BLEND);

			gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
			gl.glColor4d(1, 0, 0, 0.8);
			drawLineVawes(drawable);

			gl.glColor4d(1, 1, 0, 0.15);

			gl.glBegin(GL.GL_QUADS);
			gl.glVertex3d(0 - translation, 0, 6);
			gl.glVertex3d(18 - translation, 0, 6);
			gl.glVertex3d(18 - translation, 0, 0);
			gl.glVertex3d(0 - translation, 0, 0);
			
			gl.glColor4d(0, 1, 1, 0.15);
			
			gl.glVertex3d(0 - translation, 0, 6);
			gl.glVertex3d(0 - translation, 10, 6);
			gl.glVertex3d(0 - translation, 10, 0);
			gl.glVertex3d(0 - translation, 0, 0);
			
			gl.glColor4d(1, 0, 1, 0.15);
			
			gl.glVertex3d(0 - translation, 0, -0.01);
			gl.glVertex3d(18 - translation, 0, -0.01);
			gl.glVertex3d(18 - translation, 10, -0.01);
			gl.glVertex3d(0 - translation, 10, -0.01);
			gl.glEnd();
			gl.glLineWidth(1);
			gl.glColor3d(0.6, 0.6, 0.6);

			gl.glBegin(GL.GL_LINES);
			for (int i = 0; i < 5; i++) {
				gl.glVertex3d(0 - translation, 0, 1.5 * i);
				gl.glVertex3d(18 - translation, 0, 1.5 * i);
			}

			for (int i = 0; i < 11; i++) {
				gl.glVertex3d(0 - translation, i, 0);
				gl.glVertex3d(0 - translation, i, 6);
			}

			
			for (int i = 0; i < 5; i++) {
				gl.glVertex3d(0 - translation, 0, 1.5 * i);
				gl.glVertex3d(0 - translation, 10, 1.5 * i);
			}

			for (int i = 0; i < 19; i++) {
				gl.glVertex3d(i - translation, 10, 0);
				gl.glVertex3d(i - translation, 0, 0);
			}
			
			for (int i = 0; i < 11; i++) {
				gl.glVertex3d(0 - translation, i, 0);
				gl.glVertex3d(18 - translation, i, 0);
			}

			
			for (int i = 0; i < 19; i++) {
				gl.glVertex3d(i - translation, 0, 0);
				gl.glVertex3d(i - translation, 0, 6);
			}

			gl.glEnd();

		} else {
			drawLineVawes(drawable);
			gl.glLineWidth(1);
			gl.glColor3d(0.3, 0.3, 0.3);

			gl.glBegin(GL.GL_LINES);
			for (int i = 0; i < 5; i++) {
				gl.glVertex3d(0 - translation, 0, 1.5 * i);
				gl.glVertex3d(18 - translation, 0, 1.5 * i);
			}

			for (int i = 0; i < 11; i++) {
				gl.glVertex3d(0 - translation, i, 0);
				gl.glVertex3d(0 - translation, i, 6);
			}

			
			for (int i = 0; i < 5; i++) {
				gl.glVertex3d(0 - translation, 0, 1.5 * i);
				gl.glVertex3d(0 - translation, 10, 1.5 * i);
			}

			for (int i = 0; i < 19; i++) {
				gl.glVertex3d(i - translation, 10, 0);
				gl.glVertex3d(i - translation, 0, 0);
			}
			
			for (int i = 0; i < 11; i++) {
				gl.glVertex3d(0 - translation, i, 0);
				gl.glVertex3d(18 - translation, i, 0);
			}

			
			for (int i = 0; i < 19; i++) {
				gl.glVertex3d(i - translation, 0, 0);
				gl.glVertex3d(i - translation, 0, 6);
			}

			gl.glEnd();
		}
		
		gl.glLineWidth(1.2f);
		gl.glColor3d(1, 0, 0);
		gl.glBegin(GL.GL_LINES);
		gl.glVertex3d(18.5 - translation, 0.3, 0);
		gl.glVertex3d(18.7 - translation, 0.3, 0);
		gl.glVertex3d(18.6 - translation, 0.3, 0);
		gl.glVertex3d(18.6 - translation, 0, 0);
		
		gl.glColor3d(1, 0, 0);
		
		gl.glVertex3d(0 - translation, 10.7, 0);
		gl.glVertex3d(-0.07 - translation, 10.4, 0);
		gl.glVertex3d(0 - translation, 10.7, 0);
		gl.glVertex3d(0.07 - translation, 10.4, 0);
		gl.glVertex3d(0.04 - translation, 10.5, 0);
		gl.glVertex3d(-0.04 - translation, 10.5, 0);
		gl.glColor3d(1, 0, 0);
		
		gl.glVertex3d(0.07 - translation, 0.15, 6.5);
		gl.glVertex3d(-0.07 - translation, -0.15, 6.5);
		gl.glVertex3d(0.07 - translation, -0.15, 6.5);
		gl.glVertex3d(-0.07 - translation, 0.15, 6.5);
		gl.glEnd();

		try {
			Thread.sleep(canvasPanel.getScrollBar().getValue());

		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		if (!isPaused) {
			canvasPanel.repaint();
		}
	}
	
	/*private void drawVawes(GLDrawable drawable) {
	
	if (!isPaused) {
		x++;
		if (x >= VALUES_COUNT) {
			x = 0;
		}
	}
	Vector n2 = null;
	Vector n1 = null;
	GL gl = drawable.getGL();
	
	float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float mat_shininess[] = { 100.0f };
	float mat_ambient[] = { 1, 0.0f, 0f, 1.0f };
	float light_position[] = { 0.0f, 10.0f, -5, 0.0f };
	gl.glShadeModel (GL.GL_SMOOTH);
	
	gl.glMaterialfv(GL.GL_FRONT, GL.GL_AMBIENT_AND_DIFFUSE, mat_ambient);
	gl.glMaterialfv(GL.GL_FRONT, GL.GL_SPECULAR, mat_specular);
	gl.glMaterialfv(GL.GL_FRONT, GL.GL_SHININESS, mat_shininess);
	gl.glLightfv(GL.GL_LIGHT0, GL.GL_POSITION, light_position);
	gl.glEnable(GL.GL_LIGHTING);
	gl.glEnable(GL.GL_LIGHT0);
	
	//zkusit udelat normaly a osvetlit to
	//gl.glPointSize(3);
	//gl.glPolygonMode(GL.GL_FRONT_AND_BACK, GL.GL_LINE);
	for (int i = 0; i < VALUES_COUNT-x-1; i++) {
		gl.glBegin(GL.GL_TRIANGLE_STRIP);
		for (int j = 0; j < valuesArray.size() ;j++) {
			double[] v = valuesArray.get(j);
			if (j < valuesArray.size()-1) {
				double[] v2 = valuesArray.get(j+1);
				double x1 = ((double)(i+1)/30);
				double x2 = ((double)(i+2)/30);
				double y1 = v[i+x];
				double y2 = v[i+x+1];
				double y3 = v2[i+x];
				double y4 = v2[i+x+1];
				double z1 = (double)(j-5)/2;
				double z2 = (double)(j-5+1)/2;
				Vector vec1 = new Vector(new Vertex(x1,y1,z1),new Vertex(x1,y3,z2));
				Vector vec2 = new Vector(new Vertex(x1,y1,z1),new Vertex(x2,y2,z1));
				n1 = Vector.crossProduct(vec2, vec1);
				Vector.normalize(n1);
				
				Vector vec3 = new Vector(new Vertex(x2,y4,z2),new Vertex(x2,y2,z1));
				Vector vec4 = new Vector(new Vertex(x2,y4,z2),new Vertex(x1,y3,z2));
				n2 = Vector.crossProduct(vec4, vec3);
				Vector.normalize(n2);
			}
			
			gl.glNormal3d(n1.getX(), n1.getY(), n1.getZ());
			//gl.glNormal3d(0, 1, 0);
			gl.glVertex3d(((double)(i+1)/30)-translation, v[i+x], (double)(j+5)/2);
			//if (i == 0) {
				gl.glNormal3d(n1.getX(), n1.getY(), n1.getZ());
			//} else {
				//gl.glNormal3d(n2.getX(), n2.getY(), n2.getZ());
			//gl.glNormal3d(0, 1, 0);
			//}
			gl.glVertex3d(((double)(i+2)/30)-translation, v[i+x+1], (double)(j+5)/2);
		}
		gl.glEnd();
		
	}
	gl.glBegin(GL.GL_TRIANGLE_STRIP);
	for (int j = 0; j < valuesArray.size() ;j++) {
		double[] v = valuesArray.get(j);
		gl.glVertex3d(((double)(VALUES_COUNT-x)/30)-translation, v[VALUES_COUNT-1], (double)(j+5)/2);
		gl.glVertex3d(((double)(VALUES_COUNT-x+1)/30)-translation, v[0], (double)(j+5)/2);
	}
	gl.glEnd();
	for (int i = VALUES_COUNT-x; i < VALUES_COUNT-1; i++) {
		gl.glBegin(GL.GL_TRIANGLE_STRIP);
		for (int j = 0; j < valuesArray.size() ;j++) {
			double[] v = valuesArray.get(j);
			gl.glVertex3d(((double)(i+1)/30)-translation, v[x-(VALUES_COUNT-i)], (double)(j+5)/2);
			gl.glVertex3d(((double)(i+2)/30)-translation, v[x-(VALUES_COUNT-i)+1], (double)(j+5)/2);
			
		}
		gl.glEnd();
	}
	}*/

	/*private void drawLineVawes2(GLDrawable drawable) {

	if (!isPaused) {
	time++;
	x++;
	if (x >= VALUES_COUNT) {
		x = 0;
	}
	}
	GL gl = drawable.getGL();
	//GLU glu = drawable.getGLU();
	//zkusit udelat normaly a osvetlit to
	gl.glPointSize(3);
	//gl.glPolygonMode(GL.GL_FRONT_AND_BACK, GL.GL_POINT);
	for (int j = 0; j < valuesArray.size() ;j++) {
	double[] v = valuesArray.get(j);
	gl.glColor3d((double)(j)/(double)valuesArray.size(), 0, 1-(double)(j)/(double)valuesArray.size());
	gl.glBegin(GL.GL_LINE_STRIP);
	for (int i = 0; i < VALUES_COUNT-x-1; i++) {
		gl.glVertex3d(((double)(i+1)/40)-translation, v[i+x], (double)(j+5)/2);
		gl.glVertex3d(((double)(i+2)/40)-translation, v[i+x+1], (double)(j+5)/2);
	}
	gl.glEnd();
	
	}
	gl.glBegin(GL.GL_LINES);
	for (int j = 0; j < valuesArray.size() ;j++) {
	double[] v = valuesArray.get(j);
	gl.glColor3d((double)(j)/(double)valuesArray.size(), 0, 1-(double)(j)/(double)valuesArray.size());
	gl.glVertex3d(((double)(VALUES_COUNT-x)/40)-translation, v[VALUES_COUNT-1], (double)(j+5)/2);
	gl.glVertex3d(((double)(VALUES_COUNT-x+1)/40)-translation, v[0], (double)(j+5)/2);
	}
	gl.glEnd();
	for (int j = 0; j < valuesArray.size() ;j++) {
		double[] v = valuesArray.get(j);
		gl.glColor3d((double)(j)/(double)valuesArray.size(), 0, 1-(double)(j)/(double)valuesArray.size());
		gl.glBegin(GL.GL_LINE_STRIP);
		for (int i = VALUES_COUNT-x; i < VALUES_COUNT-1; i++) {
		gl.glVertex3d(((double)(i+1)/40)-translation, v[x-(VALUES_COUNT-i)], (double)(j+5)/2);
		gl.glVertex3d(((double)(i+2)/40)-translation, v[x-(VALUES_COUNT-i)+1], (double)(j+5)/2);
		}
	gl.glEnd();
	}
	}*/

	private void drawLineVawes(GLDrawable drawable) {
		if (!isPaused) {
			time = Long.parseLong(canvasPanel.getTime().getText());
			if (canvasPanel.getTimePlus().isSelected()) {
				time--;
			} else {
				time++;
			}
		}
		GL gl = drawable.getGL();

		for (int j = 0; j < vawesCount; j++) {
			ArrayList<Double> values = vArray.get(j);
			if (canvasPanel.getFill().isSelected()) {
				gl.glLineWidth(1);
				gl.glBegin(GL.GL_QUADS);
				gl.glColor3d(0, 1, 0);
				for (int i = 0; i < VALUES_COUNT - 1; i++) {
					gl.glVertex3d(((double) (i) / 40) - translation, values
							.get(i), j * 1.5);
					gl.glVertex3d(((double) (i + 1) / 40) - translation, values
							.get(i + 1), j * 1.5);
					gl.glVertex3d(((double) (i + 1) / 40) - translation, 0,
							j * 1.5);
					gl
							.glVertex3d(((double) (i) / 40) - translation, 0,
									j * 1.5);
				}
				gl.glEnd();
				gl.glLineWidth(1f);

			} else {
				gl.glLineWidth(1.5f);

			}
			gl.glColor3d(1, 0, 0);

			gl.glBegin(GL.GL_LINE_STRIP);
			for (int i = 0; i < VALUES_COUNT - 1; i++) {
				gl.glVertex3d(((double) (i) / 40) - translation, values.get(i),
						j * 1.5);
				gl.glVertex3d(((double) (i + 1) / 40) - translation, values
						.get(i + 1), j * 1.5);
			}
			gl.glEnd();
		}
		if (!isPaused()) {
			recompute();
		}
	}

	private void recompute() {
		canvasPanel.getTime().repaint();

		for (int j = 0; j < vawesCount; j++) {
			ArrayList<Double> values = vArray.get(j);
			if (canvasPanel.getTimePlus().isSelected()) {
				values.remove(values.size() - 1);
			} else {
				values.remove(0);
			}

			double cy = 0;
			for (int l = -vawesCountForAdding/2; l < vawesCountForAdding/2; l++) {
				double fi = ((double) (VALUES_COUNT + time) / 360) * Math.PI
						* ((k + (double) l * step));
				if (canvasPanel.getOmegaSQRT() != null
						&& canvasPanel.getOmegaSQRT().isSelected()) {
					double ff = Math.sqrt(Math.PI * ((k + (double) l * step))
							* Math.PI * ((k + (double) l * step)) + omegap
							* omegap);
					fi = ((double) (VALUES_COUNT + time) / 360) * ff;
				}
				cy += amplitude
						* Math.cos(((k + (double) l * step) * (j * 0.5) - fi));

			}
			cy = cy / (vawesCountForAdding+1);
			if (canvasPanel.getTimePlus().isSelected()) {
				values.add(0, cy);
			} else {
				values.add(cy);
			}
		}
		canvasPanel.getTime().setText(String.valueOf(time));
	}

	public void displayChanged(GLDrawable arg0, boolean arg1, boolean arg2) {

	}

	public void init(GLDrawable arg0) {
		GL gl = arg0.getGL();

		gl.glClearColor(0.8f, 0.8f, 0.8f, 1.0f);
		gl.glEnable(GL.GL_DEPTH_TEST);
		int[] viewport = new int[4];
		gl.glGetIntegerv(GL.GL_VIEWPORT, viewport);
		gl.glShadeModel(GL.GL_FLAT);
	}

	public void reshape(GLDrawable drawable, int arg1, int arg2, int width,
			int height) {
		GL gl = drawable.getGL();
		GLU glu = drawable.getGLU();
		gl.glViewport(0, 0, width, height);
		gl.glMatrixMode(GL.GL_PROJECTION);
		gl.glLoadIdentity();
		glu.gluPerspective(60, 1, 0.1, 5);
	}

	public CameraSettings getCamSettings() {
		return camSettings;
	}

	public boolean isPaused() {
		return isPaused;
	}

	public synchronized void setPaused(boolean isPaused) {
		this.isPaused = isPaused;
	}

	public synchronized long getTime() {
		return time;
	}

	public synchronized void setTime(long time) {
		this.time = time;
	}

}
