import java.lang.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class PhyWaterSim extends JApplet implements Runnable {

  DoubleBufferedPanel Draw = new DoubleBufferedPanel();
  Polygon b = new Polygon();

  Water water = new Water(800, 400);

  static int DRAWSIZE_X = 800;
  static int DRAWSIZE_Y = 400;

  boolean mutex = false;

  int corkPos = 400;

  double time = 0;
  Thread t;
  JPanel Tools = new JPanel();
  JComboBox cbWave = new JComboBox();
  JSlider sDepth = new JSlider();
  JSlider sFrequency = new JSlider();
  JSlider sWavelength = new JSlider();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JSlider sAmplitude = new JSlider();
  JCheckBox cDepth = new JCheckBox();
  JToggleButton bEnable = new JToggleButton();
  public PhyWaterSim() throws HeadlessException {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void init() {
    t = new Thread(this);
    t.start();
  }

  public void run() {
    while (true) {
      water.refreshWater(time, cbWave.getSelectedIndex());
      time += 0.001;
      repaint();

      try {
        t.sleep(100);
      }
      catch (InterruptedException e) {}
    }
  }

  public void stop() {
    t.stop();
  }

  public void paint(Graphics g) {
    if (Draw.bufferGraphics != null) {
      water.drawWater(Draw.bufferGraphics);
      water.drawCork(Draw.bufferGraphics, corkPos);
      Draw.repaint();
    }
    super.paint(g);
  }

  public void resetSim() {
    time = 0;
    resetWater();
  }

  public void resetWater() {
    water.resetWater();
  }

  private void jbInit() throws Exception {
    Draw.setForeground(SystemColor.control);
    Draw.setMaximumSize(new Dimension(800, 400));
    Draw.setMinimumSize(new Dimension(800, 400));
    Draw.setPreferredSize(new Dimension(800, 400));
    Draw.addMouseListener(new PhyWaterSim_Draw_mouseAdapter(this));
    Draw.setLayout(null);
    this.getContentPane().setBackground(SystemColor.control);
    this.setForeground(SystemColor.control);
    Tools.setMaximumSize(new Dimension(800, 100));
    Tools.setMinimumSize(new Dimension(800, 100));
    Tools.setPreferredSize(new Dimension(800, 100));
    Tools.setLayout(null);
    cbWave.setBounds(new Rectangle(5, 6, 155, 20));
    cbWave.addActionListener(new PhyWaterSim_cbWave_actionAdapter(this));
    sDepth.setLabelTable(null);
    sDepth.setMajorTickSpacing(30);
    sDepth.setMaximum(250);
    sDepth.setMinimum(20);
    sDepth.setPaintTicks(false);
    sDepth.setPaintLabels(false);
    sDepth.setPaintTrack(true);
    sDepth.setEnabled(false);
    sDepth.setBounds(new Rectangle(93, 69, 154, 26));
    sDepth.addChangeListener(new PhyWaterSim_sDepth_changeAdapter(this));
    sFrequency.setMaximumSize(new Dimension(600, 50));
    sFrequency.setMinimumSize(new Dimension(600, 50));
    sFrequency.setPreferredSize(new Dimension(600, 50));
    sFrequency.setBounds(new Rectangle(324, 35, 231, 24));
    sFrequency.addChangeListener(new PhyWaterSim_sFrequency_changeAdapter(this));
    sWavelength.setMaximum(1000);
    sWavelength.setMaximumSize(new Dimension(600, 50));
    sWavelength.setMinimumSize(new Dimension(600, 50));
    sWavelength.setPreferredSize(new Dimension(231, 24));
    sWavelength.setBounds(new Rectangle(324, 5, 231, 24));
    sWavelength.addChangeListener(new PhyWaterSim_sWavelength_changeAdapter(this));
    jLabel1.setToolTipText("");
    jLabel1.setText("Frequency");
    jLabel1.setBounds(new Rectangle(255, 39, 67, 15));
    jLabel3.setText("Wavelength");
    jLabel3.setBounds(new Rectangle(254, 9, 69, 15));
    jLabel4.setRequestFocusEnabled(false);
    jLabel4.setToolTipText("");
    jLabel4.setText("Amplitude");
    jLabel4.setBounds(new Rectangle(256, 73, 64, 15));
    sAmplitude.setMaximum(50);
    sAmplitude.setMaximumSize(new Dimension(600, 50));
    sAmplitude.setMinimumSize(new Dimension(600, 50));
    sAmplitude.setPreferredSize(new Dimension(231, 24));
    sAmplitude.setBounds(new Rectangle(324, 66, 231, 24));
    sAmplitude.addChangeListener(new PhyWaterSim_sAmplitude_changeAdapter(this));
    cDepth.setToolTipText("");
    cDepth.setActionCommand("");
    cDepth.setText("Water depth");
    cDepth.setBounds(new Rectangle(0, 69, 96, 23));
    cDepth.addActionListener(new PhyWaterSim_cDepth_actionAdapter(this));
    cDepth.addItemListener(new PhyWaterSim_cDepth_itemAdapter(this));
    bEnable.setToolTipText("");
    bEnable.setText("Enable");
    bEnable.setBounds(new Rectangle(165, 6, 79, 20));
    bEnable.addMouseListener(new PhyWaterSim_bEnable_mouseAdapter(this));
    this.getContentPane().add(Draw, java.awt.BorderLayout.CENTER);
    this.getContentPane().add(Tools, java.awt.BorderLayout.NORTH);
    Tools.add(cbWave);
    Tools.add(jLabel3);
    Tools.add(jLabel1);
    Tools.add(jLabel4);
    Tools.add(sWavelength);
    Tools.add(sFrequency);
    Tools.add(sAmplitude);
    Tools.add(bEnable);
        Tools.add(cDepth);
        Tools.add(sDepth);
        Draw.init(DRAWSIZE_X, DRAWSIZE_Y);

    sDepth.setValue(water.depth);

    sWavelength.setValue(1);
    sAmplitude.setValue(0);
    sFrequency.setValue(0);
    bEnable.setSelected(false);


    // init cbWave
    cbWave.addItem(new String("All waves"));
    for (int i = 0; i < 10; i++) {
      String s = "Wave " + Integer.toString(i + 1) + " [disabled]";
      cbWave.addItem(s);
    }

    // init cbSettings

  }

  public void cDepth_itemStateChanged(ItemEvent e) {
    if (e.getStateChange() == ItemEvent.DESELECTED) {
      water.shallow = false;
      sDepth.setEnabled(false);
    }
    else {
      sDepth.setEnabled(true);
      water.shallow = true;
    }
    resetSim();
  }

  public void Draw_mouseClicked(MouseEvent e) {
    corkPos = e.getX();
    resetWater();
  }

  public void cDepth_actionPerformed(ActionEvent e) {

  }

  public void sDepth_stateChanged(ChangeEvent e) {
    water.changeDepth(sDepth.getValue());
    resetWater();
  }

  public void cbWave_actionPerformed(ActionEvent e) {
    int index = cbWave.getSelectedIndex();
    if (index > 0 && index <= 10) {
      // enable stuff
      sWavelength.setEnabled(true);
      sAmplitude.setEnabled(true);
      sFrequency.setEnabled(true);
      bEnable.setEnabled(true);
      // load items into sliders
      Wave w = water.getWave(index);
      // changing to new values
      mutex = true;
      sWavelength.setValue(water.getWave(index).m_Wavelength);
      sAmplitude.setValue(water.getWave(index).m_Amplitude);
      sFrequency.setValue(water.getWave(index).m_Frequency);
      bEnable.setSelected(water.getWave(index).m_Active);
      mutex = false;
    }
    else if (index == 0) {
      sWavelength.setEnabled(false);
      sAmplitude.setEnabled(false);
      sFrequency.setEnabled(false);
      bEnable.setEnabled(false);
    }
    resetSim();
  }

  public void bEnable_mouseClicked(MouseEvent e) {
    boolean selected = bEnable.isSelected();
    int index = cbWave.getSelectedIndex();
    Wave w = water.getWave(index);
    if (w != null) {
      w.m_Active = selected;

      cbWave.removeItemAt(index);
      String s;

      if(selected)
      {
        s = "Wave " + Integer.toString(index) + " [enabled]";
      }
      else
      {
        s = "Wave " + Integer.toString(index) + " [disabled]";
      }

      cbWave.insertItemAt( s, index );

      cbWave.setSelectedIndex( index );
    }
  }

  public void sFrequency_stateChanged(ChangeEvent e) {
    changeWave();
  }

  public void sWavelength_stateChanged(ChangeEvent e) {
    changeWave();
  }

  public void sAmplitude_stateChanged(ChangeEvent e) {
    changeWave();
  }

  public void changeWave() {
    if(mutex) return;
    int index =  cbWave.getSelectedIndex();
    Wave w = water.getWave( cbWave.getSelectedIndex() );
    if(w != null)
    {
      w.Change(sWavelength.getValue(), sFrequency.getValue(), sAmplitude.getValue());
      resetWater();
    }
  }

  class PhyWaterSim_bEnable_mouseAdapter
      extends MouseAdapter {
    private PhyWaterSim adaptee;
    PhyWaterSim_bEnable_mouseAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
      adaptee.bEnable_mouseClicked(e);
    }
  }

  class PhyWaterSim_cbWave_actionAdapter
      implements ActionListener {
    private PhyWaterSim adaptee;
    PhyWaterSim_cbWave_actionAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.cbWave_actionPerformed(e);
    }
  }

  class PhyWaterSim_sDepth_changeAdapter
      implements ChangeListener {
    private PhyWaterSim adaptee;
    PhyWaterSim_sDepth_changeAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void stateChanged(ChangeEvent e) {
      adaptee.sDepth_stateChanged(e);
    }
  }

  class PhyWaterSim_cDepth_actionAdapter
      implements ActionListener {
    private PhyWaterSim adaptee;
    PhyWaterSim_cDepth_actionAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
      adaptee.cDepth_actionPerformed(e);
    }
  }

  class PhyWaterSim_cDepth_itemAdapter
      implements ItemListener {
    private PhyWaterSim adaptee;
    PhyWaterSim_cDepth_itemAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void itemStateChanged(ItemEvent e) {
      adaptee.cDepth_itemStateChanged(e);
    }
  }

  class PhyWaterSim_Draw_mouseAdapter
      extends MouseAdapter {
    private PhyWaterSim adaptee;
    PhyWaterSim_Draw_mouseAdapter(PhyWaterSim adaptee) {
      this.adaptee = adaptee;
    }

    public void mouseClicked(MouseEvent e) {
      adaptee.Draw_mouseClicked(e);
    }
  }
}

class PhyWaterSim_sAmplitude_changeAdapter
    implements ChangeListener {
  private PhyWaterSim adaptee;
  PhyWaterSim_sAmplitude_changeAdapter(PhyWaterSim adaptee) {
    this.adaptee = adaptee;
  }

  public void stateChanged(ChangeEvent e) {
    adaptee.sAmplitude_stateChanged(e);
  }
}

class PhyWaterSim_sFrequency_changeAdapter
    implements ChangeListener {
  private PhyWaterSim adaptee;
  PhyWaterSim_sFrequency_changeAdapter(PhyWaterSim adaptee) {
    this.adaptee = adaptee;
  }

  public void stateChanged(ChangeEvent e) {
    adaptee.sFrequency_stateChanged(e);
  }
}

class PhyWaterSim_sWavelength_changeAdapter
    implements ChangeListener {
  private PhyWaterSim adaptee;
  PhyWaterSim_sWavelength_changeAdapter(PhyWaterSim adaptee) {
    this.adaptee = adaptee;
  }

  public void stateChanged(ChangeEvent e) {
    adaptee.sWavelength_stateChanged(e);
  }
}
