import java.awt.*;

public class Water {
  public Water() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  static int fromTop = 100;

  public Polygon m_Body = new Polygon();
  private Polygon m_Cork = new Polygon();
  private Polygon m_Bottom = new Polygon();
  public int m_Count;
  public Wave waves[] = new Wave[10];
  public int m_WaveCount = 10;

  private boolean disregardOne = false;

  public boolean shallow = false;
  public int depth = 150;

  private int m_Width;
  private int m_Height;

  public Water(int width, int height) {
    m_Count = width + 800;

    // make up polygon with water surface
    for (int i = 0; i < m_Count; i++) {
      m_Body.addPoint(0, 0);
    }
    m_Body.addPoint(width, height);
    m_Body.addPoint(0, height);

    m_Width = width;
    m_Height = height;

    // make up rock bottom
    m_Bottom.addPoint(0,height);
    m_Bottom.addPoint(width,height);
    m_Bottom.addPoint(width,fromTop+depth);
    m_Bottom.addPoint(0,fromTop+depth);

    for(int i=0;i<10;i++) {
      waves[i] = new Wave(1,0,0);
    }
  }

  public Polygon getPolyBody() {
    return m_Body;
  }

  public void changeDepth(int val) {
    depth = val;
    m_Bottom.ypoints[2] = fromTop+depth;
    m_Bottom.ypoints[3] = fromTop+depth;
  }

  public void refreshWater( double time, int id ) {
      int y = 0;
      for (int xp = 0; xp < m_Count; xp++) {
        int x = xp - 400;
        double offx = 0,offy = 0;
        for(int i=0;i<m_WaveCount;i++) {
          if(waves[i] == null || !waves[i].m_Active || ( id != 0 && (id-1) != i ) ) continue;
          offx += waves[i].getOffsetX(x, y, time, shallow, depth);
          offy += waves[i].getOffsetY(x, y, time, shallow, depth);
        }
        m_Body.xpoints[xp] = (int) java.lang.Math.round(x + offx);
        m_Body.ypoints[xp] = (int) java.lang.Math.round(y + offy) + fromTop;
      }
  }

  public Wave getWave(int id) {
    id = id - 1;
    if( id >= 0 && id < 10) return waves[id];
    else return null;
  }

  public void drawWater( Graphics g ) {
    g.setColor(Color.white);
    g.fillRect(0, 0, m_Width, m_Height);
    g.setColor(Color.blue);
    g.drawPolygon(m_Body);
    g.fillPolygon(m_Body);

    if(shallow) {
      g.setColor(Color.lightGray);
      g.drawPolygon(m_Bottom);
      g.fillPolygon(m_Bottom);
    }
  }

  public void resetWater() {
    m_Cork.reset();
    disregardOne = true;
  }

  public void drawCork( Graphics g, int corkPos) {

      if(disregardOne) {
          disregardOne = false;
          return;
      }

    int x = m_Body.xpoints[corkPos+400];
    int y = m_Body.ypoints[corkPos+400];

    g.setColor(Color.red);
    g.drawRect(x - 1, y - 1, 2, 2);
    m_Cork.addPoint(x, y);
    g.setColor(Color.red);

    for (int i = 1; i < m_Cork.npoints; i++) {
      g.drawLine(m_Cork.xpoints[i - 1], m_Cork.ypoints[i - 1], m_Cork.xpoints[i], m_Cork.ypoints[i]);
    }
  }

  private void jbInit() throws Exception {
  }
}
