
public class Wave {

  public int m_Amplitude;
  public double m_Omega;
  public double m_Wavenumber;

  public int m_Wavelength;
  public int m_Frequency;

  public boolean m_Active = false;

  public Wave(int w, int f, int a) {
    Change(w,f,a);
  }

  public void Change(int w, int f, int a) {
    m_Wavelength = w;
    m_Frequency = f;
    m_Omega = 2*java.lang.Math.PI*f;
    m_Amplitude = a;
    m_Wavenumber = (2*java.lang.Math.PI)/w;
  }

  public double getOffsetX( int x, int y, double time, boolean shallow, double depth ) {
    double offx;
    if( shallow )
      offx = m_Amplitude * ( 1/( m_Wavenumber * depth ) ) * java.lang.Math.exp( m_Wavenumber * y ) * java.lang.Math.sin ( m_Omega * time - m_Wavenumber * x ) + x;
    else
      offx = m_Amplitude * java.lang.Math.exp( m_Wavenumber * y ) * java.lang.Math.sin ( m_Omega * time - m_Wavenumber * x ) + x ;
    return x - offx;
  }

  public double getOffsetY( int x, int y, double time, boolean shallow, double depth ) {
    double offy;
    if (shallow)
      offy = m_Amplitude * (1 + y / depth ) * java.lang.Math.cos(m_Omega * time - m_Wavenumber * x);
    else
      offy = m_Amplitude * java.lang.Math.exp(m_Wavenumber * y) * java.lang.Math.cos(m_Omega * time - m_Wavenumber * x);
    return y - offy;
  }

}
